## org.apache.fop.layout
Class LineArea

    java.lang.Object
      |
      +--org.apache.fop.layout.Box
            |
            +--org.apache.fop.layout.Area
                  |
                  +--org.apache.fop.layout.LineArea

public class LineArea
extends Area

Field Summary
`protected int` `allocationHeight`
`protected java.lang.String` `country`
`protected int` `embeddedLinkStart`
`protected int` `endIndent`
`protected int` `finalWidth`
`protected int` `halfLeading`
`protected int` `hyphenate`
`protected char` `hyphenationChar`
`protected int` `hyphenationPushCharacterCount`
`protected int` `hyphenationRemainCharacterCount`
`protected java.lang.String` `language`
`protected int` `lineHeight`
`protected int` `nominalFontSize`
`protected int` `nominalGlyphHeight`
`protected static int` `NOTHING`
`protected java.util.Vector` `pendingAreas`
`protected int` `pendingWidth`
`protected int` `prev`
`protected boolean` `prevLTState`
`protected boolean` `prevOlState`
`protected boolean` `prevUlState`
`protected int` `spaceWidth`
`protected int` `startIndent`
`protected static int` `TEXT`
`protected static int` `WHITESPACE`

Fields inherited from class org.apache.fop.layout.Area

`allocationWidth, backgroundColor, borderColorBottom, borderColorLeft, borderColorRight, borderColorTop, borderStyleBottom, borderStyleLeft, borderStyleRight, borderStyleTop, borderWidthBottom, borderWidthLeft, borderWidthRight, borderWidthTop, children, contentRectangleWidth, currentHeight, foCreator, fontState, maxHeight, paddingBottom, paddingLeft, paddingRight, paddingTop, page, tableCellXOffset`

Fields inherited from class org.apache.fop.layout.Box
`areaTree, parent`

Constructor Summary
`LineArea(FontState fontState, int lineHeight, int halfLeading, int allocationWidth, int startIndent, int endIndent, LineArea prevLineArea)`

Method Summary
`int` `addCharacter(char data, LinkSet ls, boolean ul)` adds a single character to the line area tree
`void` `addInlineArea(Area box)`
`void` `addInlineSpace(InlineSpace is, int spaceWidth)`
`void` `addLeader(int leaderPattern, int leaderLengthMinimum, int leaderLengthOptimum, int leaderLengthMaximum, int ruleStyle, int ruleThickness, int leaderPatternWidth, int leaderAlignment)` adds a Leader; actually the method receives the leader properties and creates a leader area or an inline area which is appended to the children of the containing line area.
`int` `addPageNumberCitation(java.lang.String refid, LinkSet ls)`
`void` `addPending()` adds pending inline areas to the line area normally done, when the line area is filled and added as child to the parent block area
`int` `addText(char[] odata, int start, int end, LinkSet ls, TextState textState)` adds text to line area
`void` `align(int type)` aligns line area
`void` `changeColor(float red, float green, float blue)`
`void` `changeFont(FontState fontState)`
`void` `changeHyphenation(java.lang.String language, java.lang.String country, int hyphenate, char hyphenationChar, int hyphenationPushCharacterCount, int hyphenationRemainCharacterCount)` sets hyphenation related traits: language, country, hyphenate, hyphenation-character and minimum number of character to remain one the previous line and to be on the next line.
`void` `changeVerticalAlign(int vAlign)`
`void` `changeWhiteSpaceCollapse(int whiteSpaceCollapse)`
`void` `changeWrapOption(int wrapOption)`
`int` `doHyphenation(char[] characters, int position, int wordStart, int remainingWidth)` extracts word for hyphenation and calls hyphenation package, handles cases of inword punctuation and quotation marks at the beginning of words, but not in a internationalized way
`int` `getEndIndent()`
`int` `getHeight()`
`java.util.Vector` `getPendingAreas()`
`int` `getPendingWidth()`
`int` `getPlacementOffset()`
`int` `getRemainingWidth()`
`int` `getStartIndent()`
`boolean` `isEmpty()`
`void` `render(Renderer renderer)`
`void` `setLinkSet(LinkSet ls)`
`void` `setPendingAreas(java.util.Vector areas)`
`void` `setPendingWidth(int width)`
`void` `verticalAlign()` Balance (vertically) the inline areas within this line.

Methods inherited from class org.apache.fop.layout.Area

`addChild, addChildAtStart, addDisplaySpace, end, getAbsoluteHeight, getAllocationWidth, getBackgroundColor, getChildren, getContentHeight, getContentWidth, getfoCreator, getFontInfo, getFontState, getIDReferences, getMaxHeight, getNearestAncestorAreaContainer, getPaddingBottom, getPaddingLeft, getPaddingRight, getPaddingTop, getPage, getParent, getTableCellXOffset, increaseAbsoluteHeight, increaseHeight, remove, removeChild, removeChild, setAbsoluteHeight, setAllocationWidth, setBackgroundColor, setBorderColor, setBorderStyle, setBorderWidth, setHeight, setIDReferences, setMaxHeight, setPadding, setPage, setParent, setTableCellXOffset, spaceLeft, start`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### lineHeight

    protected int lineHeight

### halfLeading

    protected int halfLeading

### nominalFontSize

    protected int nominalFontSize

### nominalGlyphHeight

    protected int nominalGlyphHeight

### allocationHeight

    protected int allocationHeight

### startIndent

    protected int startIndent

### endIndent

    protected int endIndent

### hyphenate

    protected int hyphenate

### hyphenationChar

    protected char hyphenationChar

### hyphenationPushCharacterCount

    protected int hyphenationPushCharacterCount

### hyphenationRemainCharacterCount

    protected int hyphenationRemainCharacterCount

### language

    protected java.lang.String language

### country

    protected java.lang.String country

### finalWidth

    protected int finalWidth

### embeddedLinkStart

    protected int embeddedLinkStart

### NOTHING

    protected static final int NOTHING

### WHITESPACE

    protected static final int WHITESPACE

### TEXT

    protected static final int TEXT

### prev

    protected int prev

### spaceWidth

    protected int spaceWidth

### pendingAreas

    protected java.util.Vector pendingAreas

### pendingWidth

    protected int pendingWidth

### prevUlState

    protected boolean prevUlState

### prevOlState

    protected boolean prevOlState

### prevLTState

    protected boolean prevLTState

Constructor Detail

### LineArea

    public LineArea(FontState fontState,
                    int lineHeight,
                    int halfLeading,
                    int allocationWidth,
                    int startIndent,
                    int endIndent,
                    LineArea prevLineArea)

Method Detail

### render

    public void render(Renderer renderer)

  Overrides:
    render in class Box

### addPageNumberCitation

    public int addPageNumberCitation(java.lang.String refid,
                                     LinkSet ls)

### addText

    public int addText(char[] odata,
                       int start,
                       int end,
                       LinkSet ls,
                       TextState textState)

  adds text to line area
  Returns:
    int character position

### addLeader

    public void addLeader(int leaderPattern,
                          int leaderLengthMinimum,
                          int leaderLengthOptimum,
                          int leaderLengthMaximum,
                          int ruleStyle,
                          int ruleThickness,
                          int leaderPatternWidth,
                          int leaderAlignment)

  adds a Leader; actually the method receives the leader properties and creates a leader area or an inline area which is appended to the children of the containing line area.
  leader pattern use-content is not implemented.

### addPending

    public void addPending()

  adds pending inline areas to the line area normally done, when the line area is filled and added as child to the parent block area

### align

    public void align(int type)

  aligns line area

### verticalAlign

    public void verticalAlign()

  Balance (vertically) the inline areas within this line.

### changeColor

    public void changeColor(float red,
                            float green,
                            float blue)

### changeFont

    public void changeFont(FontState fontState)

### changeWhiteSpaceCollapse

    public void changeWhiteSpaceCollapse(int whiteSpaceCollapse)

### changeWrapOption

    public void changeWrapOption(int wrapOption)

### changeVerticalAlign

    public void changeVerticalAlign(int vAlign)

### getEndIndent

    public int getEndIndent()

### getHeight

    public int getHeight()

  Overrides:
    getHeight in class Area

### getPlacementOffset

    public int getPlacementOffset()

### getStartIndent

    public int getStartIndent()

### isEmpty

    public boolean isEmpty()

### getPendingAreas

    public java.util.Vector getPendingAreas()

### getPendingWidth

    public int getPendingWidth()

### setPendingAreas

    public void setPendingAreas(java.util.Vector areas)

### setPendingWidth

    public void setPendingWidth(int width)

### changeHyphenation

    public void changeHyphenation(java.lang.String language,
                                  java.lang.String country,
                                  int hyphenate,
                                  char hyphenationChar,
                                  int hyphenationPushCharacterCount,
                                  int hyphenationRemainCharacterCount)

  sets hyphenation related traits: language, country, hyphenate, hyphenation-character and minimum number of character to remain one the previous line and to be on the next line.

### doHyphenation

    public int doHyphenation(char[] characters,
                             int position,
                             int wordStart,
                             int remainingWidth)

  extracts word for hyphenation and calls hyphenation package, handles cases of inword punctuation and quotation marks at the beginning of words, but not in a internationalized way

### getRemainingWidth

    public int getRemainingWidth()

### setLinkSet

    public void setLinkSet(LinkSet ls)

### addInlineArea

    public void addInlineArea(Area box)

### addInlineSpace

    public void addInlineSpace(InlineSpace is,
                               int spaceWidth)

### addCharacter

    public int addCharacter(char data,
                            LinkSet ls,
                            boolean ul)

  adds a single character to the line area tree

Copyright © 1999-2001 Apache Software Foundation. All Rights Reserved.